package cn.com.infosec.asn1.ocsp;

import cn.com.infosec.asn1.ASN1Choice;
import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1OctetString;
import cn.com.infosec.asn1.ASN1TaggedObject;
import cn.com.infosec.asn1.DEREncodable;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DEROctetString;
import cn.com.infosec.asn1.DERTaggedObject;
import cn.com.infosec.asn1.x509.X509Name;

public class ResponderID extends ASN1Encodable implements ASN1Choice {
   private DEREncodable value;

   public ResponderID(ASN1OctetString value) {
      this.value = value;
   }

   public ResponderID(X509Name value) {
      this.value = value;
   }

   public static ResponderID getInstance(Object obj) {
      if (obj != null && !(obj instanceof ResponderID)) {
         if (obj instanceof DEROctetString) {
            return new ResponderID((DEROctetString)obj);
         } else if (obj instanceof ASN1TaggedObject) {
            ASN1TaggedObject obj1;
            return (obj1 = (ASN1TaggedObject)obj).getTagNo() == 1 ? new ResponderID(X509Name.getInstance(obj1, true)) : new ResponderID(ASN1OctetString.getInstance(obj1, true));
         } else {
            return new ResponderID(X509Name.getInstance(obj));
         }
      } else {
         return (ResponderID)obj;
      }
   }

   public static ResponderID getInstance(ASN1TaggedObject obj, boolean explicit) {
      return getInstance(obj.getObject());
   }

   public DERObject toASN1Object() {
      DEREncodable var1;
      return (var1 = this.value) instanceof ASN1OctetString ? new DERTaggedObject(true, 2, var1) : new DERTaggedObject(true, 1, var1);
   }
}
